import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

public class MultilineClientFrame extends javax.swing.JFrame {
	public static Integer onlyLine = new Integer(1);
	public static boolean allLines = true;
	public static boolean popups = true;
	public static String mode;
	public static WCListener parent;
	public static java.util.Hashtable popcount;
    
    public MultilineClientFrame(WCListener parent, boolean popups, String mode) {
    	this.parent = parent;
    	this.popups = popups;
    	this.mode = mode;
        initComponents();
        setSize(480, 280);
    }

    private void initComponents() {
    	popcount = new java.util.Hashtable();
        java.awt.GridBagConstraints gridBagConstraints;

        lineLabel = new JLabel();
        timeLabel = new JLabel();
        nameLabel = new JLabel();
        lineText1 = new JTextField();
        timeText1 = new JTextField();
        nameText1 = new JTextField();
        phoneLabel = new JLabel();
        phoneText1 = new JTextField();
        clearButton = new JButton();
        lineText2 = new JTextField();
        timeText2 = new JTextField();
        phoneText2 = new JTextField();
        nameText2 = new JTextField();
        lineText3 = new JTextField();
        timeText3 = new JTextField();
        timeText4 = new JTextField();
        lineText4 = new JTextField();
        phoneText3 = new JTextField();
        phoneText4 = new JTextField();
        nameText3 = new JTextField();
        nameText4 = new JTextField();
        jLabel1 = new JLabel();
        dataTextarea = new JTextPane();
        dataTextarea.setCaretPosition(0);
        dataTextarea.setMargin(new java.awt.Insets(2,2,2,2));
        StyledDocument styledDoc = dataTextarea.getStyledDocument();
        if (styledDoc instanceof AbstractDocument) {
            doc = (AbstractDocument)styledDoc;
        } else {
            System.err.println("Text pane's document isn't an AbstractDocument!");
            System.exit(-1);
        }

        dataScroll = new JScrollPane(dataTextarea);
        checkPop = new JCheckBox();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("WhozzCalling Listener");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        lineLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        lineLabel.setText("Line  ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        getContentPane().add(lineLabel, gridBagConstraints);

        timeLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        timeLabel.setText("Time          ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(timeLabel, gridBagConstraints);

        nameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        nameLabel.setText("Name             ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(nameLabel, gridBagConstraints);

        checkPop.setFont(new java.awt.Font("Dialog", 0, 12));
        checkPop.setText("Pop-ups");
        checkPop.setMnemonic(java.awt.event.KeyEvent.VK_P);
//        checkPop.setDisplayedMnemonicIndex(0);
        checkPop.setSelected(popups);
        checkPop.setBorder(new javax.swing.border.EmptyBorder(0,0,0,0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(checkPop, gridBagConstraints);

        lineText1.setBackground(new java.awt.Color(218, 218, 218));
        lineText1.setFont(new java.awt.Font("Dialog", 1, 12));
        lineText1.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        getContentPane().add(lineText1, gridBagConstraints);

        timeText1.setBackground(new java.awt.Color(218, 218, 218));
        timeText1.setFont(new java.awt.Font("Dialog", 1, 12));
        timeText1.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(timeText1, gridBagConstraints);

        nameText1.setBackground(new java.awt.Color(218, 218, 218));
        nameText1.setFont(new java.awt.Font("Dialog", 1, 12));
        nameText1.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(nameText1, gridBagConstraints);

        phoneLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        phoneLabel.setText("Phone Number      ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(phoneLabel, gridBagConstraints);

        phoneText1.setBackground(new java.awt.Color(218, 218, 218));
        phoneText1.setFont(new java.awt.Font("Dialog", 1, 12));
        phoneText1.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(phoneText1, gridBagConstraints);

        clearButton.setBackground(new java.awt.Color(228, 228, 228));
        clearButton.setFont(new java.awt.Font("Dialog", 0, 12));
        clearButton.setText("Clear Window");
        clearButton.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 2;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(clearButton, gridBagConstraints);

        dataScroll.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(dataScroll, gridBagConstraints);

        lineText2.setBackground(new java.awt.Color(218, 218, 218));
        lineText2.setFont(new java.awt.Font("Dialog", 1, 12));
        lineText2.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(lineText2, gridBagConstraints);

        timeText2.setBackground(new java.awt.Color(218, 218, 218));
        timeText2.setFont(new java.awt.Font("Dialog", 1, 12));
        timeText2.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(timeText2, gridBagConstraints);

        phoneText2.setBackground(new java.awt.Color(218, 218, 218));
        phoneText2.setFont(new java.awt.Font("Dialog", 1, 12));
        phoneText2.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(phoneText2, gridBagConstraints);

        nameText2.setBackground(new java.awt.Color(218, 218, 218));
        nameText2.setFont(new java.awt.Font("Dialog", 1, 12));
        nameText2.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(nameText2, gridBagConstraints);

        lineText3.setBackground(new java.awt.Color(218, 218, 218));
        lineText3.setFont(new java.awt.Font("Dialog", 1, 12));
        lineText3.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(lineText3, gridBagConstraints);

        timeText3.setBackground(new java.awt.Color(218, 218, 218));
        timeText3.setFont(new java.awt.Font("Dialog", 1, 12));
        timeText3.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(timeText3, gridBagConstraints);

        timeText4.setBackground(new java.awt.Color(218, 218, 218));
        timeText4.setFont(new java.awt.Font("Dialog", 1, 12));
        timeText4.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(timeText4, gridBagConstraints);

        lineText4.setBackground(new java.awt.Color(218, 218, 218));
        lineText4.setFont(new java.awt.Font("Dialog", 1, 12));
        lineText4.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(lineText4, gridBagConstraints);

        phoneText3.setBackground(new java.awt.Color(218, 218, 218));
        phoneText3.setFont(new java.awt.Font("Dialog", 1, 12));
        phoneText3.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(phoneText3, gridBagConstraints);

        phoneText4.setBackground(new java.awt.Color(218, 218, 218));
        phoneText4.setFont(new java.awt.Font("Dialog", 1, 12));
        phoneText4.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(phoneText4, gridBagConstraints);

        nameText3.setBackground(new java.awt.Color(218, 218, 218));
        nameText3.setFont(new java.awt.Font("Dialog", 1, 12));
        nameText3.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(nameText3, gridBagConstraints);

        nameText4.setBackground(new java.awt.Color(218, 218, 218));
        nameText4.setFont(new java.awt.Font("Dialog", 1, 12));
        nameText4.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(nameText4, gridBagConstraints);

		java.net.URL imageURL = MultilineClientFrame.class.getResource("java_icon.gif");
		if (imageURL != null) {
			jLabel1.setIcon(new ImageIcon(imageURL));
		}
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jLabel1, gridBagConstraints);

        pack();

		cGrey = new java.awt.Color(218,218,218);
		cDGrey = new java.awt.Color(128,128,128);
        cBlue = new java.awt.Color(0,0,225);
        cGreen = new java.awt.Color(0,204,0);
        cBlack = new java.awt.Color(0,0,0);
        cRed = new java.awt.Color(255,0,0);
        cWhite = new java.awt.Color(255,255,255);
    }

    
    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {
    	int i;
    	
       java.util.Date ts = new java.util.Date();
       dataTextarea.setText("Window cleared on " + ts.toString() + "\n");
       for (i=1;i<5;i++){
       	setLineColor(i, cRed, cGrey);
       	setLineData(i, "", "", "", "");
       }    
    }
    
    private void exitForm(java.awt.event.WindowEvent evt) {
    	hide();
    	if(mode.equals("application"))
        	parent.shutdown(true);
    }
    
    public void updateWindow(String str, Color col){
    	
    	
    	SimpleAttributeSet attr = new SimpleAttributeSet();
    	StyleConstants.setFontFamily(attr, "Monospaced");
    	StyleConstants.setFontSize(attr, 12);
     	if (col != null){
			StyleConstants.setForeground(attr, col);
     	}else{
			StyleConstants.setForeground(attr, cBlack);
     	}
    	try{
    		doc.insertString(doc.getLength(), str + "\n", attr);
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text.");
        }
    	dataTextarea.setCaretPosition(dataTextarea.getDocument().getLength()-1);
    }
    
    public String[] callData(String cdat){
    	String cLine = "";
    	String cIO = "";
    	String cStart = "";
    	String cDur = "";
    	String cCheck = "";
    	String cRing = "";
    	String cDate = "";
    	String cTime = "";
    	String cName = "";
    	String cPhone = "";
    	int lineInt = 0;
   	
/* ABOUT PARSING WHOZZ CALLING? UNIT DATA:
 * ---------------------------------------------------------------
 * MOST OF THE TIME you will be using the "comprehensive" format,
 * and IF your WhozzCalling? unit's Echo Toggle is OFF ('e'),
 * then MOST strings you will recieve from the unit will start
 * with the 2-digit line number, and continue through the
 * character sequence ending with the name field. If this were
 * the case, then simply parsing the character positions out
 * from the start of the string will work (see commented code
 * below). The SAFER method is to take the data and parse from
 * the new line character BACKWARDS through the string.
 *
 * As well as the ECHO toggle, there are a few other cases in
 * which characters OTHER than a "comprehensive" format string may
 * be recieved:
 * 
 *    The pound sign (#) is sent by a unit after it recieves an
 *    "at sign" (@).
 *
 *    A question mark (?) is sent by a unit when any command it
 *    does not understand is recieved.
 *
 * In both cases above, the characters are NOT terminated by a
 * carriage return - line feed. This implementation strips question
 * marks, pound signs, and new line chr(13) out before attempting
 * to parse.
 *
 * Also, please note that a sort of buffer is used in both the 
 * serialConnection and UDPlistener classes to wait until a 
 * carriage return has been recieved before sending the string to
 * the MultilineClientFrame class for parsing. If you manage your
 * data stream any other way, you will need to adjust for the
 * extra characters.
 *
 * The special cases made for PRIVATE and OUT-OF-AREA data is done
 * because where the WhozzCalling? unit will space-pad every other
 * string, these two do not get padded. Easiest management of this
 * is to simply identify the case first, and add the padding
 * before processing.
 */
 
    	if (cdat.endsWith("PRIVATE")) cdat = cdat + "        "; // WhozzCalling units DO NOT pad
    	if (cdat.endsWith("OUT-OF-AREA")) cdat = cdat + "    "; // PRIVATE or OUT-OF-AREA data streams
    	int strlen = cdat.length();

    	try{
	    	cName = cdat.substring(strlen-15);
	    	cPhone = cdat.substring(strlen-30,strlen-16);
	    	cTime = cdat.substring(strlen-39,strlen-17);
	    	cDate = cdat.substring(strlen-45,strlen-40);
	    	cRing = cdat.substring(strlen-48,strlen-46);
	    	cCheck = cdat.substring(strlen-50,strlen-47);
	    	cDur = cdat.substring(strlen-55,strlen-51);
	    	cStart = cdat.substring(strlen-57,strlen-56);
	    	cIO = cdat.substring(strlen-59,strlen-58);
	    	cLine = cdat.substring(strlen-62,strlen-60);
     	}catch(java.lang.StringIndexOutOfBoundsException e){
     		System.err.println("Error parsing data: " + e.toString());
		}
		
/*		Hey, if you think that you'll ALWAYS get a proper data string, and nothing else
 		try parsing from the left:
 
    	try{
	    	cLine = cdat.substring(0,2);
	    	cIO = cdat.substring(3,5);
	    	cStart = cdat.substring(5,6);
	    	cDur = cdat.substring(7, 11);
	    	cCheck = cdat.substring(12, 13);
	    	cRing = cdat.substring(14, 15);
	    	cDate = cdat.substring(17,22);
	    	cTime = cdat.substring(23,31);
	    	cPhone = cdat.substring(32, 46);
	    	cName = cdat.substring(47);
     	}catch(java.lang.StringIndexOutOfBoundsException e){
     		System.err.println("Error parsing data: " + e.toString());
		}
		
*/
    	try{
	    	lineInt = Integer.parseInt(cLine);
	    	if (lineInt > 4) lineInt = lineInt % 4;
	    }catch(java.lang.NumberFormatException e){
				System.err.println(cdat);
	    }
	    
		if (allLines || cLine.equals(onlyLine.toString()) ){
			if (cStart.equals("S")){
				if (cIO.startsWith("I")){ 
					setLineColor(lineInt, cWhite, cBlue); // Start Inbound
					updateWindow(cdat, cBlue);
					if (popups && checkPop.isSelected()){ // popup
						popOpen(lineInt, cPhone, cName);
					}
				}else{
					setLineColor(lineInt, cWhite, cGreen); // Start Outbound
					updateWindow(cdat, cGreen);
				}
			}else{
				if (cIO.startsWith("I")){ 
					setLineColor(lineInt, cBlue, cGrey); // End Inbound
					updateWindow(cdat, cDGrey);
				}else if (cIO.startsWith("O")){ 
					setLineColor(lineInt, cGreen, cGrey); // End Outbound
					updateWindow(cdat, cDGrey);
				}else{ 
					setLineColor(lineInt, cRed, cGrey); // Everything Else
					updateWindow(cdat, cBlack);
				}
			}
		}
		
		setLineData(lineInt, cLine, cTime, cName, cPhone);
		String[] retData = {cLine, cIO, cStart, cDur, cCheck, cRing, cDate, cTime, cPhone, cName};
		return(retData);
    }
    
    public void popOpen(int line, String phone, String name){
    	popwin pop = new popwin(this, false, line, phone, name);
    }
    
	private static void setLineColor(int line, java.awt.Color Fcolor, java.awt.Color Bcolor){
		switch (line){
			case 1:
				lineText1.setBackground(Bcolor);
				timeText1.setBackground(Bcolor);
				nameText1.setBackground(Bcolor);
				phoneText1.setBackground(Bcolor);

				lineText1.setForeground(Fcolor);
				timeText1.setForeground(Fcolor);
				nameText1.setForeground(Fcolor);
				phoneText1.setForeground(Fcolor);
			break;
			case 2:
				lineText2.setBackground(Bcolor);
				timeText2.setBackground(Bcolor);
				nameText2.setBackground(Bcolor);
				phoneText2.setBackground(Bcolor);

				lineText2.setForeground(Fcolor);
				timeText2.setForeground(Fcolor);
				nameText2.setForeground(Fcolor);
				phoneText2.setForeground(Fcolor);
			break;
			case 3:
				lineText3.setBackground(Bcolor);
				timeText3.setBackground(Bcolor);
				nameText3.setBackground(Bcolor);
				phoneText3.setBackground(Bcolor);

				lineText3.setForeground(Fcolor);
				timeText3.setForeground(Fcolor);
				nameText3.setForeground(Fcolor);
				phoneText3.setForeground(Fcolor);
			break;
			default:
				lineText4.setBackground(Bcolor);
				timeText4.setBackground(Bcolor);
				nameText4.setBackground(Bcolor);
				phoneText4.setBackground(Bcolor);

				lineText4.setForeground(Fcolor);
				timeText4.setForeground(Fcolor);
				nameText4.setForeground(Fcolor);
				phoneText4.setForeground(Fcolor);
			break;
		}
	}
	
	private static void setLineData(int line, String cLine, String cTime, String cName, String cPhone){
		switch (line){
			case 1:
				lineText1.setText(cLine);
				timeText1.setText(cTime);
				nameText1.setText(cName);
				phoneText1.setText(cPhone);
			break;
			case 2:
				lineText2.setText(cLine);
				timeText2.setText(cTime);
				nameText2.setText(cName);
				phoneText2.setText(cPhone);
			break;
			case 3:
				lineText3.setText(cLine);
				timeText3.setText(cTime);
				nameText3.setText(cName);
				phoneText3.setText(cPhone);
			break;
			default:
				lineText4.setText(cLine);
				timeText4.setText(cTime);
				nameText4.setText(cName);
				phoneText4.setText(cPhone);
			break;
		}
	}

    private JButton clearButton;
    private JLabel lineLabel;
    private static JTextField lineText1;
    private static JTextField lineText2;
    private static JTextField lineText3;
    private static JTextField lineText4;
    private JLabel nameLabel;
    private static JTextField nameText1;
    private static JTextField nameText2;
    private static JTextField nameText3;
    private static JTextField nameText4;
    private JLabel phoneLabel;
    private static JTextField phoneText1;
    private static JTextField phoneText2;
    private static JTextField phoneText3;
    private static JTextField phoneText4;
    private JLabel timeLabel;
    private static JTextField timeText1;
    private static JTextField timeText2;
    private static JTextField timeText3;
    private static JTextField timeText4;
    private JLabel jLabel1;
    private static JTextPane dataTextarea;
    private static AbstractDocument doc;
    private JScrollPane dataScroll;
    private JCheckBox checkPop;
    
    public static java.awt.Color cGrey;
    public static java.awt.Color cDGrey;
    public static java.awt.Color cBlue;
    public static java.awt.Color cGreen;
    public static java.awt.Color cBlack;
    public static java.awt.Color cRed;
    public static java.awt.Color cWhite;
    
    
}
