import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.FontMetrics.*;

public class popwin extends javax.swing.JWindow {
	public static String data;
	public static int line;
	public static MultilineClientFrame parent;

    public popwin(MultilineClientFrame parent, boolean modal, int line, String phone, String name) {
        this.parent = parent;
        this.line = line;
    	this.data = line + ":  " + phone + " " + name;
        initComponents();
        show();
    }
    
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
		java.awt.Color cWhite = new java.awt.Color(255,255,255);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog();
            }
        });

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 24));
        jLabel1.setText(data);
        jLabel1.setBackground(cWhite);
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);
        FontMetrics fm = this.getFontMetrics(jLabel1.getFont());
		java.awt.geom.Rectangle2D rect = fm.getStringBounds(data, this.getGraphics());

        getContentPane().setBackground(cWhite);

		int textHeight = (int)(rect.getHeight()); 
		int textWidth  = (int)(rect.getWidth());

        pack();
        this.setSize(textWidth + 8, textHeight + 2);
        this.setLocation(0, (line - 1) * (textHeight + 2));
        this.show();

		ActionListener listener = new ActionListener () {
			public void actionPerformed (ActionEvent event) {
				closeDialog();
			}
		};
		Timer timer = new Timer(500, listener);
		timer.setRepeats(false);
		timer.setInitialDelay(5000);
		timer.start();        
    }
    
    private void closeDialog() {
        this.setVisible(false);
        this.dispose();
    }
    
    
    private JLabel jLabel1;
  
}
